---
# Manage Keycloak client used for OpenTalk backend
- name: Create or update Keycloak client {{ BACKEND_CLIENT_ID | default('OtBackend') }}
  community.general.keycloak_client:
    auth_keycloak_url: "{{ AUTH_KEYCLOAK_URL }}"
    auth_realm: "{{ AUTH_REALM | default('master') }}"
    auth_username: "{{ AUTH_USERNAME }}"
    auth_password: "{{ AUTH_PASSWORD }}"
    realm: "{{ KEYCLOAK_TARGET_REALM }}"
    client_id: "{{ BACKEND_CLIENT_ID | default('OtBackend') }}"
    name: "OpenTalk Backend"
    admin_url: ""
    base_url: ""
    description: ""
    enabled: true
    public_client: false
    direct_access_grants_enabled: false
    service_accounts_enabled: true
    client_authenticator_type: client-secret
    secret: "{{ BACKEND_CLIENT_SECRET | default(lookup('password', '/dev/null chars=ascii_uppercase,ascii_lowercase,digits length=32')) }}"
    redirect_uris: "{{ BACKEND_CLIENT_REDIRECT_URIS }}"
    web_origins: "{{ BACKEND_CLIENT_WEB_ORIGINS }}"
    attributes:
      client_credentials.use_refresh_token: false
      post.logout.redirect.uris: "+"
      display.on.consent.screen: false
      oauth2.device.authorization.grant.enabled: false
      backchannel.logout.revoke.offline.tokens: false
      use.refresh.tokens: true
      exclude.session.state.from.auth.response: false
    protocol_mappers:
      - config:
          user.session.note: clientAddress
          userinfo.token.claim: true
          id.token.claim: true
          access.token.claim: true
          claim.name: clientAddress
          jsonType.label: String
        name: Client IP Address
        protocol: openid-connect
        protocolMapper: oidc-usersessionmodel-note-mapper
        consentRequired: false
      - config:
          user.session.note: clientId
          userinfo.token.claim: true
          id.token.claim: true
          access.token.claim: true
          claim.name: clientId
          jsonType.label: String
        name: Client ID
        protocol: openid-connect
        protocolMapper: oidc-usersessionmodel-note-mapper
        consentRequired: false
      - config:
          user.session.note: clientHost
          userinfo.token.claim: true
          id.token.claim: true
          access.token.claim: true
          claim.name: clientHost
          jsonType.label: String
        name: Client Host
        protocol: openid-connect
        protocolMapper: oidc-usersessionmodel-note-mapper
        consentRequired: false
    state: present
  tags:
    - client_backend

- name: "Map a client roles to service account user for client {{ BACKEND_CLIENT_ID | default('OtBackend') }}"
  community.general.keycloak_user_rolemapping:
    auth_keycloak_url: "{{ AUTH_KEYCLOAK_URL }}"
    auth_realm: "{{ AUTH_REALM | default('master') }}"
    auth_username: "{{ AUTH_USERNAME }}"
    auth_password: "{{ AUTH_PASSWORD }}"
    realm: "{{ KEYCLOAK_TARGET_REALM }}"
    client_id: "{{ REALM_MANAGEMENT_CLIENT_ID | default('realm-management') }}"
    service_account_user_client_id: "{{ BACKEND_CLIENT_ID | default('OtBackend') }}"
    roles:
      - name: view-users
      - name: query-users
    state: present
  tags:
    - client_backend
